#include <curl/curl.h>
#include <curl/types.h>
#include <curl/easy.h>
#include "inetlib.h"

#ifdef  __cplusplus
extern "C" {
#endif

size_t getdatacallback(void* ptr_paquet, size_t taille, size_t nmemb,void* ptr_buffer)
{
	int tailletotale = taille * nmemb;
	BUFFER* buffer = (BUFFER*) ptr_buffer;
	buffer->donnees = (char*) realloc(buffer->donnees, buffer->taille + tailletotale + 1);
	memcpy(&(buffer->donnees[buffer->taille]),ptr_paquet,tailletotale);
	buffer->taille += tailletotale;
	buffer->donnees[buffer->taille] = '\0' ;
	return tailletotale;
}


long geterrcode(CURL* inetresshandle)
{
	long * errcode;
	errcode = new long ;
	curl_easy_getinfo(inetresshandle,CURLINFO_RESPONSE_CODE,errcode);
	return *(errcode);
}

char* gettype(CURL* inetresshandle)
{
	char* chaineresult = NULL;//le null sert a enlever un warning
	curl_easy_getinfo(inetresshandle,CURLINFO_CONTENT_TYPE,chaineresult);
	return chaineresult;
}


/*size_t getheaderscallback( void* ptr, size_t size,size_t nmemb, void* headers)
{
	return 0;
}*/

CURL* priseEnChargeFichierDistant(char* URL,char* proxy,BUFFER* data)
{
	curl_global_init(CURL_GLOBAL_WIN32);
	
	CURL* handle = NULL ;
	int i = 0 ;
	while (handle == NULL && i <= 3)  //en cas de pb
	{
		handle = curl_easy_init();
		i++;
	}

	curl_easy_setopt(handle, CURLOPT_URL, URL);
	curl_easy_setopt(handle, CURLOPT_PROXY, proxy);
	//proxy et url definis

	curl_easy_setopt(handle, CURLOPT_WRITEFUNCTION, getdatacallback);
	curl_easy_setopt(handle, CURLOPT_WRITEDATA, (void *)data);
	//callback et buffer definis

	curl_easy_perform(handle);
	
	return handle;
}

BUFFER* createbuffer()
{
	BUFFER* retour;
	retour = new BUFFER;
	retour->donnees = NULL;
	retour->taille = 0;
	return retour;
}


bool uninithandle(CURL* handle)
{
	curl_easy_cleanup(handle);
	return true;
}

bool uninit(CURL* handle,BUFFER* data)
{
	free(data);
	curl_easy_cleanup(handle);
	return true;
}

bool uninitbuffer(BUFFER* data)
{
	free(data);
	return true;
}

#ifdef  __cplusplus
}
#endif